import { useEffect } from 'react';
import { useSelector } from 'react-redux';
import PropTypes from 'prop-types';
import NProgress from 'nprogress';
import { pendingTasksSelector, usePreviousPendingTasks } from './hooks';

var Spinner = function Spinner(_ref) {
  var config = _ref.config;
  var pendingTasks = useSelector(pendingTasksSelector);
  var prevPendingTasks = usePreviousPendingTasks(pendingTasks);
  var diff = pendingTasks - prevPendingTasks;
  useEffect(function () {
    if (diff > 0) {
      NProgress.start();
    }

    if (diff < 0) {
      NProgress.inc();
    }

    if (pendingTasks === 0) {
      NProgress.done();
    }
  }, [pendingTasks]);
  useEffect(function () {
    NProgress.configure(config);
  }, []);
  return null;
};

Spinner.propTypes = {
  config: PropTypes.object,
  pendingTasks: PropTypes.number
};
Spinner.defaultProps = {
  config: {}
};
export default Spinner;