"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = require("react");

var _reactRedux = require("react-redux");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _nprogress = _interopRequireDefault(require("nprogress"));

var _hooks = require("./hooks");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Spinner = function Spinner(_ref) {
  var config = _ref.config;
  var pendingTasks = (0, _reactRedux.useSelector)(_hooks.pendingTasksSelector);
  var prevPendingTasks = (0, _hooks.usePreviousPendingTasks)(pendingTasks);
  var diff = pendingTasks - prevPendingTasks;
  (0, _react.useEffect)(function () {
    if (diff > 0) {
      _nprogress["default"].start();
    }

    if (diff < 0) {
      _nprogress["default"].inc();
    }

    if (pendingTasks === 0) {
      _nprogress["default"].done();
    }
  }, [pendingTasks]);
  (0, _react.useEffect)(function () {
    _nprogress["default"].configure(config);
  }, []);
  return null;
};

Spinner.propTypes = {
  config: _propTypes["default"].object,
  pendingTasks: _propTypes["default"].number
};
Spinner.defaultProps = {
  config: {}
};
var _default = Spinner;
exports["default"] = _default;